// PerfData.h: interface for the CPerfData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PERFDATA_H__0FCEA9DB_340F_4FFB_82C0_DF9ADF0A0526__INCLUDED_)
#define AFX_PERFDATA_H__0FCEA9DB_340F_4FFB_82C0_DF9ADF0A0526__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "StatusBar.h"

//
// CLASS:   CPerfData
//
// PURPOSE: This class represents the interface that
//          a viewer window uses to report performance data
//          from the running effect.
//
class CPerfData  
{
public:
	CPerfData(CStatusBar* bar);
	virtual ~CPerfData();

    void SetViewSize(int w, int h);
  
    void SetPixelsPerSec(float pps, int pass);
    //
    // FPS reporting can be switched on or off;
    // if it is on, the FPS count is inferred from the
    // frequency of calls to SetPixelsPerSec() (which
    // is assumed to be called on a per-frame basis.)
    void EnableFPS(bool f);

private:
    CStatusBar* m_bar;
    ULONG m_ticks;
    DWORD m_startMS;
    float m_fps;
    bool  m_enableFPS;
};

#endif // !defined(AFX_PERFDATA_H__0FCEA9DB_340F_4FFB_82C0_DF9ADF0A0526__INCLUDED_)
