// RemoveDlg.h: interface for the CRemoveDlg class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REMOVEDLG_H__D0F3C91E_FEB5_4D14_A3A2_AD3D75D10982__INCLUDED_)
#define AFX_REMOVEDLG_H__D0F3C91E_FEB5_4D14_A3A2_AD3D75D10982__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "stdafx.h"
#include "resource.h"
#include "UnregisterServer.h"
#include "NewDlg.h"
#include <windowsx.h>
#include <vector>
#include <algorithm>
using namespace std;

// {E44A391E-8C72-4164-A82C-426E3541C40B}

class CRemoveDlg : public CDialogImpl<CRemoveDlg>  
{
    typedef struct {
        CLSID   clsid;
        LPTSTR  progID;
    } ComponentData;

    vector<ComponentData> clsidMap;

public:
	enum { IDD = IDD_DELDOC };

private:

    // this could be sep'ed out. ToDo.
    static ComponentData mkComponentData(CLSID& clsid, LPTSTR str) {

        ComponentData cData;
        LPTSTR pProgID = new TCHAR[_tcslen(str) + 1];
        _tcscpy(pProgID, str);

        memcpy(&cData.clsid,&clsid,sizeof(CLSID));
        cData.progID = pProgID;

        return cData;
    }

    static bool lessCData(ComponentData c1, ComponentData c2) {  return (_tcsicmp(c1.progID,c2.progID) < 0); }

public:
    CRemoveDlg();
	virtual ~CRemoveDlg();

	BEGIN_MSG_MAP(CNewDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		CenterWindow(GetParent());
        Populate(GetDlgItem(IDC_LISTBOX), clsidMap);
        sort(clsidMap.begin(),clsidMap.end(),lessCData);
		return TRUE;
	}

	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
        bool hasSelection = false;
        if (wID == IDOK) {
            int count = ListBox_GetSelCount(GetDlgItem(IDC_LISTBOX));
            if (count != LB_ERR) {
                int* items = (int*)_alloca(sizeof(int) * count);
                ListBox_GetSelItems(GetDlgItem(IDC_LISTBOX), count, items);
                int i;
                for (i=0; i < count ; i++) {
                   UnregisterServer((clsidMap[items[i]].clsid));                
                }
                hasSelection = true;
            }
        }
		EndDialog(wID);
		return 0;
	}

    static void Populate(HWND hWnd, vector<ComponentData>& clsidMap)
    {
        USES_CONVERSION;
        ICatInformation *pci = 0;

        static const GUID CATID_PanImage = 
            { 0xe44a391e, 0x8c72, 0x4164, { 0xa8, 0x2c, 0x42, 0x6e, 0x35, 0x41, 0xc4, 0xb } };

        // Fire up the Component Category Manager
        HRESULT hr = CoCreateInstance(
            CLSID_StdComponentCategoriesMgr, 0, 
            CLSCTX_ALL, IID_ICatInformation, (void**)&pci);


        if (SUCCEEDED(hr)) {
            // fish out the components that implement the PanImage category.
            IEnumCLSID *pec = 0;
            CATID rgcid;
            rgcid = CATID_PanImage;

            hr = pci->EnumClassesOfCategories(1, &rgcid, 0, 0, &pec);
            if (SUCCEEDED(hr)) {
                // walk list of CLSIDs 64 at a time
                enum { MAX = 64 };
                LPOLESTR clsidStr = NULL;
                TCHAR buf[MAX_PATH];
                HKEY hKey;
                CLSID rgclsid[MAX];
                hr = S_OK;
                DWORD dwType = REG_SZ;
                DWORD cbData = MAX_PATH - 1;
                LONG lr;
                do {
                    ULONG cActual = 0;
                    hr = pec->Next(MAX, rgclsid, &cActual);
                    if (SUCCEEDED(hr)) {
                        for (ULONG i = 0; i < cActual; i++) {
                            if (clsidStr) {
                                CoTaskMemFree(clsidStr);
                                clsidStr = NULL;
                            }
                            StringFromCLSID(rgclsid[i], &clsidStr);
                            _stprintf(buf, TEXT("CLSID\\%s"), OLE2T(clsidStr));
                            lr = RegOpenKeyEx(HKEY_CLASSES_ROOT,
                                         buf,
                                         0,
                                         KEY_READ,
                                         &hKey);
                            cbData = MAX_PATH - 1;
                            if ( lr == NO_ERROR ) {
                                lr = RegQueryValueEx(hKey, NULL, NULL, &dwType, (LPBYTE)buf, &cbData);
                                if ( lr == NO_ERROR ) {
                                    ListBox_AddString(hWnd, buf);
                                    ComponentData cData = mkComponentData(rgclsid[i],buf);
                                    clsidMap.push_back(cData);
                                }
                                RegCloseKey(hKey);
                            }
                        }
                    }
                } while (hr == S_OK);
                if (clsidStr) {
                   CoTaskMemFree(clsidStr);
                   clsidStr = NULL;
                }
                pec->Release();
            }
        }
        pci->Release();
        
    }

};

#endif // !defined(AFX_REMOVEDLG_H__D0F3C91E_FEB5_4D14_A3A2_AD3D75D10982__INCLUDED_)
